diff --git a/MAINTAINERS b/MAINTAINERS
index 6dabd972c9..dd16c78f97 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -439,8 +439,7 @@ M: Cameron Esfahani <dirty@apple.com>
 M: Roman Bolshakov <r.bolshakov@yadro.com>
 W: https://wiki.qemu.org/Features/HVF
 S: Maintained
-F: accel/stubs/hvf-stub.c
-F: target/i386/hvf/
+F: target/i386/accel/hvf/
 F: include/sysemu/hvf.h
 
 WHPX CPUs
diff --git a/target/i386/hvf/README.md b/target/i386/accel/hvf/README.md
similarity index 100%
rename from target/i386/hvf/README.md
rename to target/i386/accel/hvf/README.md
diff --git a/target/i386/hvf/hvf-cpus.c b/target/i386/accel/hvf/hvf-cpus.c
similarity index 100%
rename from target/i386/hvf/hvf-cpus.c
rename to target/i386/accel/hvf/hvf-cpus.c
diff --git a/target/i386/hvf/hvf-cpus.h b/target/i386/accel/hvf/hvf-cpus.h
similarity index 100%
rename from target/i386/hvf/hvf-cpus.h
rename to target/i386/accel/hvf/hvf-cpus.h
diff --git a/target/i386/hvf/hvf-i386.h b/target/i386/accel/hvf/hvf-i386.h
similarity index 100%
rename from target/i386/hvf/hvf-i386.h
rename to target/i386/accel/hvf/hvf-i386.h
diff --git a/target/i386/hvf/hvf.c b/target/i386/accel/hvf/hvf.c
similarity index 100%
rename from target/i386/hvf/hvf.c
rename to target/i386/accel/hvf/hvf.c
diff --git a/target/i386/hvf/meson.build b/target/i386/accel/hvf/meson.build
similarity index 100%
rename from target/i386/hvf/meson.build
rename to target/i386/accel/hvf/meson.build
diff --git a/target/i386/hvf/panic.h b/target/i386/accel/hvf/panic.h
similarity index 100%
rename from target/i386/hvf/panic.h
rename to target/i386/accel/hvf/panic.h
diff --git a/target/i386/hvf/vmcs.h b/target/i386/accel/hvf/vmcs.h
similarity index 100%
rename from target/i386/hvf/vmcs.h
rename to target/i386/accel/hvf/vmcs.h
diff --git a/target/i386/hvf/vmx.h b/target/i386/accel/hvf/vmx.h
similarity index 100%
rename from target/i386/hvf/vmx.h
rename to target/i386/accel/hvf/vmx.h
diff --git a/target/i386/hvf/x86.c b/target/i386/accel/hvf/x86.c
similarity index 100%
rename from target/i386/hvf/x86.c
rename to target/i386/accel/hvf/x86.c
diff --git a/target/i386/hvf/x86.h b/target/i386/accel/hvf/x86.h
similarity index 100%
rename from target/i386/hvf/x86.h
rename to target/i386/accel/hvf/x86.h
diff --git a/target/i386/hvf/x86_cpuid.c b/target/i386/accel/hvf/x86_cpuid.c
similarity index 100%
rename from target/i386/hvf/x86_cpuid.c
rename to target/i386/accel/hvf/x86_cpuid.c
diff --git a/target/i386/hvf/x86_decode.c b/target/i386/accel/hvf/x86_decode.c
similarity index 100%
rename from target/i386/hvf/x86_decode.c
rename to target/i386/accel/hvf/x86_decode.c
diff --git a/target/i386/hvf/x86_decode.h b/target/i386/accel/hvf/x86_decode.h
similarity index 100%
rename from target/i386/hvf/x86_decode.h
rename to target/i386/accel/hvf/x86_decode.h
diff --git a/target/i386/hvf/x86_descr.c b/target/i386/accel/hvf/x86_descr.c
similarity index 100%
rename from target/i386/hvf/x86_descr.c
rename to target/i386/accel/hvf/x86_descr.c
diff --git a/target/i386/hvf/x86_descr.h b/target/i386/accel/hvf/x86_descr.h
similarity index 100%
rename from target/i386/hvf/x86_descr.h
rename to target/i386/accel/hvf/x86_descr.h
diff --git a/target/i386/hvf/x86_emu.c b/target/i386/accel/hvf/x86_emu.c
similarity index 100%
rename from target/i386/hvf/x86_emu.c
rename to target/i386/accel/hvf/x86_emu.c
diff --git a/target/i386/hvf/x86_emu.h b/target/i386/accel/hvf/x86_emu.h
similarity index 100%
rename from target/i386/hvf/x86_emu.h
rename to target/i386/accel/hvf/x86_emu.h
diff --git a/target/i386/hvf/x86_flags.c b/target/i386/accel/hvf/x86_flags.c
similarity index 100%
rename from target/i386/hvf/x86_flags.c
rename to target/i386/accel/hvf/x86_flags.c
diff --git a/target/i386/hvf/x86_flags.h b/target/i386/accel/hvf/x86_flags.h
similarity index 100%
rename from target/i386/hvf/x86_flags.h
rename to target/i386/accel/hvf/x86_flags.h
diff --git a/target/i386/hvf/x86_mmu.c b/target/i386/accel/hvf/x86_mmu.c
similarity index 100%
rename from target/i386/hvf/x86_mmu.c
rename to target/i386/accel/hvf/x86_mmu.c
diff --git a/target/i386/hvf/x86_mmu.h b/target/i386/accel/hvf/x86_mmu.h
similarity index 100%
rename from target/i386/hvf/x86_mmu.h
rename to target/i386/accel/hvf/x86_mmu.h
diff --git a/target/i386/hvf/x86_task.c b/target/i386/accel/hvf/x86_task.c
similarity index 100%
rename from target/i386/hvf/x86_task.c
rename to target/i386/accel/hvf/x86_task.c
diff --git a/target/i386/hvf/x86_task.h b/target/i386/accel/hvf/x86_task.h
similarity index 100%
rename from target/i386/hvf/x86_task.h
rename to target/i386/accel/hvf/x86_task.h
diff --git a/target/i386/hvf/x86hvf.c b/target/i386/accel/hvf/x86hvf.c
similarity index 100%
rename from target/i386/hvf/x86hvf.c
rename to target/i386/accel/hvf/x86hvf.c
diff --git a/target/i386/hvf/x86hvf.h b/target/i386/accel/hvf/x86hvf.h
similarity index 100%
rename from target/i386/hvf/x86hvf.h
rename to target/i386/accel/hvf/x86hvf.h
diff --git a/target/i386/meson.build b/target/i386/meson.build
index 34ec93dbef..da070e4e54 100644
--- a/target/i386/meson.build
+++ b/target/i386/meson.build
@@ -31,7 +31,7 @@ i386_softmmu_ss.add(files(
 subdir('accel/kvm')
 subdir('accel/hax')
 subdir('accel/whpx')
-subdir('hvf')
+subdir('accel/hvf')
 
 target_arch += {'i386': i386_ss}
 target_softmmu_arch += {'i386': i386_softmmu_ss}